searchNodes=[{"doc":"A high performance web crawler in Elixir.","ref":"Crawler.html","title":"Crawler","type":"module"},{"doc":"Enqueues a crawl, via Crawler.QueueHandler.enqueue/1. This is the default crawl behaviour as the queue determines when an actual crawl should happen based on the available workers and the rate limit. The queue kicks off Crawler.Dispatcher.Worker which in turn calls Crawler.crawl_now/1.","ref":"Crawler.html#crawl/2","title":"Crawler.crawl/2","type":"function"},{"doc":"Crawls immediately, this is used by Crawler.Dispatcher.Worker.start_link/1. For general purpose use cases, always use Crawler.crawl/2 instead.","ref":"Crawler.html#crawl_now/1","title":"Crawler.crawl_now/1","type":"function"},{"doc":"Pauses the crawler.","ref":"Crawler.html#pause/1","title":"Crawler.pause/1","type":"function"},{"doc":"Resumes the crawler after it was paused.","ref":"Crawler.html#resume/1","title":"Crawler.resume/1","type":"function"},{"doc":"Crawler is an application that gets started automatically with: a Crawler.Store that initiates a Registry for keeping internal data","ref":"Crawler.html#start/2","title":"Crawler.start/2","type":"function"},{"doc":"Stops the crawler.","ref":"Crawler.html#stop/1","title":"Crawler.stop/1","type":"function"},{"doc":"Dispatches requests to a queue for crawling.","ref":"Crawler.Dispatcher.html","title":"Crawler.Dispatcher","type":"module"},{"doc":"Takes the request argument which is a tuple containing either: {_, link, _, url} when it&#39;s a link that got transformed into a URL {_, url} when it&#39;s a URL already And issues Crawler.crawl/2 to initiate the crawl.","ref":"Crawler.Dispatcher.html#dispatch/2","title":"Crawler.Dispatcher.dispatch/2","type":"function"},{"doc":"A worker that performs the crawling.","ref":"Crawler.Dispatcher.Worker.html","title":"Crawler.Dispatcher.Worker","type":"module"},{"doc":"Kicks off Crawler.crawl_now/1.","ref":"Crawler.Dispatcher.Worker.html#start_link/1","title":"Crawler.Dispatcher.Worker.start_link/1","type":"function"},{"doc":"Fetches pages and perform tasks on them.","ref":"Crawler.Fetcher.html","title":"Crawler.Fetcher","type":"module"},{"doc":"Fetches a URL by: verifying whether the URL needs fetching through Crawler.Fetcher.Policer.police/1 recording data for internal use through Crawler.Fetcher.Recorder.record/1 fetching the URL performing retries upon failed fetches through Crawler.Fetcher.Retrier.perform/2","ref":"Crawler.Fetcher.html#fetch/1","title":"Crawler.Fetcher.fetch/1","type":"function"},{"doc":"Captures and prepares HTTP response headers.","ref":"Crawler.Fetcher.HeaderPreparer.html","title":"Crawler.Fetcher.HeaderPreparer","type":"module"},{"doc":"Captures and prepares HTTP response headers. Examples iex&gt; HeaderPreparer.prepare( iex&gt; [{&quot;Content-Type&quot;, &quot;text/html&quot;}], iex&gt; %{} iex&gt; ) %{headers: [{&quot;Content-Type&quot;, &quot;text/html&quot;}], content_type: &quot;text/html&quot;} iex&gt; HeaderPreparer.prepare( iex&gt; [{&quot;Content-Type&quot;, &quot;text/css&quot;}], iex&gt; %{} iex&gt; ) %{headers: [{&quot;Content-Type&quot;, &quot;text/css&quot;}], content_type: &quot;text/css&quot;} iex&gt; HeaderPreparer.prepare( iex&gt; [{&quot;Content-Type&quot;, &quot;image/png; blah&quot;}], iex&gt; %{} iex&gt; ) %{headers: [{&quot;Content-Type&quot;, &quot;image/png; blah&quot;}], content_type: &quot;image/png&quot;}","ref":"Crawler.Fetcher.HeaderPreparer.html#prepare/2","title":"Crawler.Fetcher.HeaderPreparer.prepare/2","type":"function"},{"doc":"Modifies request options and headers before dispatch.","ref":"Crawler.Fetcher.Modifier.html","title":"Crawler.Fetcher.Modifier","type":"module"},{"doc":"Allows modifing headers prior to making a crawl request. Example implementation def headers(opts) do if opts[:url] == &quot;http://modifier&quot; do [{&quot;Referer&quot;, &quot;http://fetcher&quot;}] end [] end","ref":"Crawler.Fetcher.Modifier.html#headers/1","title":"Crawler.Fetcher.Modifier.headers/1","type":"function"},{"doc":"Allows passing opts to httpPoison prior to making the crawl request Example implementation def opts(opts) do if opts[:url] == &quot;http://modifier&quot; do # add a new pool to hackney [hackney: [pool: :modifier]] end [] end","ref":"Crawler.Fetcher.Modifier.html#opts/1","title":"Crawler.Fetcher.Modifier.opts/1","type":"function"},{"doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html","title":"Crawler.Fetcher.Modifier.Spec","type":"behaviour"},{"doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#c:headers/1","title":"Crawler.Fetcher.Modifier.Spec.headers/1","type":"callback"},{"doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#c:opts/1","title":"Crawler.Fetcher.Modifier.Spec.opts/1","type":"callback"},{"doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#t:header/0","title":"Crawler.Fetcher.Modifier.Spec.header/0","type":"type"},{"doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#t:opts/0","title":"Crawler.Fetcher.Modifier.Spec.opts/0","type":"type"},{"doc":"","ref":"Crawler.Fetcher.Modifier.Spec.html#t:url/0","title":"Crawler.Fetcher.Modifier.Spec.url/0","type":"type"},{"doc":"Checks a series of conditions to determine whether it is okay to continue.","ref":"Crawler.Fetcher.Policer.html","title":"Crawler.Fetcher.Policer","type":"module"},{"doc":"Checks a series of conditions to determine whether it is okay to continue, i.e. to allow Crawler.Fetcher.fetch/1 to begin its tasks. Examples iex&gt; Policer.police([ iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; url: &quot;http://policer/&quot;, iex&gt; url_filter: UrlFilter iex&gt; ]) {:ok, [depth: 1, max_depths: 2, url: &quot;http://policer/&quot;, url_filter: UrlFilter]} iex&gt; Policer.police([ iex&gt; depth: 2, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot; iex&gt; ]) {:error, &quot;Fetch failed &#39;within_fetch_depth?&#39;, with opts: [depth: 2, max_depths: 2, html_tag: \\&quot;a\\&quot;].&quot;} iex&gt; Policer.police([ iex&gt; depth: 3, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;img&quot;, iex&gt; url: &quot;http://policer/hi.jpg&quot;, iex&gt; url_filter: UrlFilter iex&gt; ]) {:ok, [depth: 3, max_depths: 2, html_tag: &quot;img&quot;, url: &quot;http://policer/hi.jpg&quot;, url_filter: UrlFilter]} iex&gt; Policer.police([ iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; url: &quot;ftp://hello.world&quot; iex&gt; ]) {:error, &quot;Fetch failed &#39;acceptable_uri_scheme?&#39;, with opts: [depth: 1, max_depths: 2, url: \\&quot;ftp://hello.world\\&quot;].&quot;} iex&gt; Crawler.Store.add(&quot;http://policer/exist/&quot;) iex&gt; Policer.police([ iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; url: &quot;http://policer/exist/&quot; iex&gt; ]) {:error, &quot;Fetch failed &#39;not_fetched_yet?&#39;, with opts: [depth: 1, max_depths: 2, url: \\&quot;http://policer/exist/\\&quot;].&quot;}","ref":"Crawler.Fetcher.Policer.html#police/1","title":"Crawler.Fetcher.Policer.police/1","type":"function"},{"doc":"Records information about each crawl for internal use.","ref":"Crawler.Fetcher.Recorder.html","title":"Crawler.Fetcher.Recorder","type":"module"},{"doc":"Records information about each crawl for internal use. Examples iex&gt; Recorder.record(url: &quot;url1&quot;, depth: 2) {:ok, %{depth: 3, url: &quot;url1&quot;}} iex&gt; Recorder.record(url: &quot;url2&quot;, depth: 2) iex&gt; Store.find(&quot;url2&quot;) %Page{url: &quot;url2&quot;}","ref":"Crawler.Fetcher.Recorder.html#record/1","title":"Crawler.Fetcher.Recorder.record/1","type":"function"},{"doc":"Stores page data in Crawler.Store.DB for internal or external consumption.","ref":"Crawler.Fetcher.Recorder.html#store_page/2","title":"Crawler.Fetcher.Recorder.store_page/2","type":"function"},{"doc":"Makes HTTP requests.","ref":"Crawler.Fetcher.Requester.html","title":"Crawler.Fetcher.Requester","type":"module"},{"doc":"Makes HTTP requests via Crawler.HTTP. Examples iex&gt; Requester.make(url: &quot;fake.url&quot;, modifier: Crawler.Fetcher.Modifier) {:error, %HTTPoison.Error{id: nil, reason: :nxdomain}}","ref":"Crawler.Fetcher.Requester.html#make/1","title":"Crawler.Fetcher.Requester.make/1","type":"function"},{"doc":"Handles retries for failed crawls.","ref":"Crawler.Fetcher.Retrier.html","title":"Crawler.Fetcher.Retrier","type":"module"},{"doc":"More information: https://github.com/safwank/ElixirRetry","ref":"Crawler.Fetcher.Retrier.html#perform/2","title":"Crawler.Fetcher.Retrier.perform/2","type":"function"},{"doc":"Spec for defining a fetch retrier.","ref":"Crawler.Fetcher.Retrier.Spec.html","title":"Crawler.Fetcher.Retrier.Spec","type":"behaviour"},{"doc":"","ref":"Crawler.Fetcher.Retrier.Spec.html#c:perform/2","title":"Crawler.Fetcher.Retrier.Spec.perform/2","type":"callback"},{"doc":"","ref":"Crawler.Fetcher.Retrier.Spec.html#t:fetch_url/0","title":"Crawler.Fetcher.Retrier.Spec.fetch_url/0","type":"type"},{"doc":"","ref":"Crawler.Fetcher.Retrier.Spec.html#t:opts/0","title":"Crawler.Fetcher.Retrier.Spec.opts/0","type":"type"},{"doc":"A placeholder module that lets all URLs pass through.","ref":"Crawler.Fetcher.UrlFilter.html","title":"Crawler.Fetcher.UrlFilter","type":"module"},{"doc":"Whether to pass through a given URL. true for letting the url through false for rejecting the url","ref":"Crawler.Fetcher.UrlFilter.html#filter/2","title":"Crawler.Fetcher.UrlFilter.filter/2","type":"function"},{"doc":"Spec for defining an url filter.","ref":"Crawler.Fetcher.UrlFilter.Spec.html","title":"Crawler.Fetcher.UrlFilter.Spec","type":"behaviour"},{"doc":"","ref":"Crawler.Fetcher.UrlFilter.Spec.html#c:filter/2","title":"Crawler.Fetcher.UrlFilter.Spec.filter/2","type":"callback"},{"doc":"","ref":"Crawler.Fetcher.UrlFilter.Spec.html#t:opts/0","title":"Crawler.Fetcher.UrlFilter.Spec.opts/0","type":"type"},{"doc":"","ref":"Crawler.Fetcher.UrlFilter.Spec.html#t:url/0","title":"Crawler.Fetcher.UrlFilter.Spec.url/0","type":"type"},{"doc":"Custom HTTPoison base module for potential customisation.","ref":"Crawler.HTTP.html","title":"Crawler.HTTP","type":"module"},{"doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#delete/3","title":"Crawler.HTTP.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#delete!/3","title":"Crawler.HTTP.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#get/3","title":"Crawler.HTTP.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#get!/3","title":"Crawler.HTTP.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#head/3","title":"Crawler.HTTP.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#head!/3","title":"Crawler.HTTP.head!/3","type":"function"},{"doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#options/3","title":"Crawler.HTTP.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#options!/3","title":"Crawler.HTTP.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#patch/4","title":"Crawler.HTTP.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#patch!/4","title":"Crawler.HTTP.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#post/4","title":"Crawler.HTTP.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#post!/4","title":"Crawler.HTTP.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1.","ref":"Crawler.HTTP.html#process_headers/1","title":"Crawler.HTTP.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1.","ref":"Crawler.HTTP.html#process_request_body/1","title":"Crawler.HTTP.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1.","ref":"Crawler.HTTP.html#process_request_headers/1","title":"Crawler.HTTP.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1.","ref":"Crawler.HTTP.html#process_request_options/1","title":"Crawler.HTTP.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1.","ref":"Crawler.HTTP.html#process_request_params/1","title":"Crawler.HTTP.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1.","ref":"Crawler.HTTP.html#process_request_url/1","title":"Crawler.HTTP.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1.","ref":"Crawler.HTTP.html#process_response/1","title":"Crawler.HTTP.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1.","ref":"Crawler.HTTP.html#process_response_body/1","title":"Crawler.HTTP.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1.","ref":"Crawler.HTTP.html#process_response_chunk/1","title":"Crawler.HTTP.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1.","ref":"Crawler.HTTP.html#process_response_headers/1","title":"Crawler.HTTP.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1.","ref":"Crawler.HTTP.html#process_response_status_code/1","title":"Crawler.HTTP.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1.","ref":"Crawler.HTTP.html#process_status_code/1","title":"Crawler.HTTP.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1.","ref":"Crawler.HTTP.html#process_url/1","title":"Crawler.HTTP.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"Crawler.HTTP.html#put/4","title":"Crawler.HTTP.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#put!/4","title":"Crawler.HTTP.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)","ref":"Crawler.HTTP.html#request/1","title":"Crawler.HTTP.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3, post/4, put/4, etc Args: method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}]) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])","ref":"Crawler.HTTP.html#request/5","title":"Crawler.HTTP.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Crawler.HTTP.html#request!/5","title":"Crawler.HTTP.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Crawler.HTTP.html#start/0","title":"Crawler.HTTP.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse. See request!/5 for more detailed information.","ref":"Crawler.HTTP.html#stream_next/1","title":"Crawler.HTTP.stream_next/1","type":"function"},{"doc":"","ref":"Crawler.HTTP.html#t:body/0","title":"Crawler.HTTP.body/0","type":"type"},{"doc":"","ref":"Crawler.HTTP.html#t:headers/0","title":"Crawler.HTTP.headers/0","type":"type"},{"doc":"","ref":"Crawler.HTTP.html#t:method/0","title":"Crawler.HTTP.method/0","type":"type"},{"doc":"","ref":"Crawler.HTTP.html#t:options/0","title":"Crawler.HTTP.options/0","type":"type"},{"doc":"","ref":"Crawler.HTTP.html#t:params/0","title":"Crawler.HTTP.params/0","type":"type"},{"doc":"","ref":"Crawler.HTTP.html#t:request/0","title":"Crawler.HTTP.request/0","type":"type"},{"doc":"","ref":"Crawler.HTTP.html#t:url/0","title":"Crawler.HTTP.url/0","type":"type"},{"doc":"A set of high level functions for making online and offline URLs and links.","ref":"Crawler.Linker.html","title":"Crawler.Linker","type":"module"},{"doc":"Given the current_link, it works out what the relative link should be for link. Examples iex&gt; Linker.link( iex&gt; &quot;http://another.domain/page.html&quot;, iex&gt; &quot;/dir/page2&quot; iex&gt; ) &quot;../another.domain/dir/page2&quot; iex&gt; Linker.link( iex&gt; &quot;http://another.domain/page&quot;, iex&gt; &quot;/dir/page2&quot; iex&gt; ) &quot;../../another.domain/dir/page2&quot; iex&gt; Linker.link( iex&gt; &quot;http://another.domain/parent/page&quot;, iex&gt; &quot;dir/page2&quot; iex&gt; ) &quot;../../../another.domain/parent/dir/page2&quot; iex&gt; Linker.link( iex&gt; &quot;http://another.domain/parent/page&quot;, iex&gt; &quot;../dir/page2&quot; iex&gt; ) &quot;../../../another.domain/dir/page2&quot;","ref":"Crawler.Linker.html#link/2","title":"Crawler.Linker.link/2","type":"function"},{"doc":"Given the current_link, it works out what the relative offline link should be for link. Examples iex&gt; Linker.offline_link( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;page1&quot; iex&gt; ) &quot;../../../hello.world/dir/page1/index.html&quot; iex&gt; Linker.offline_link( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;page1.html&quot; iex&gt; ) &quot;../../../hello.world/dir/page1.html&quot; iex&gt; Linker.offline_link( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;../page1&quot; iex&gt; ) &quot;../../../hello.world/page1/index.html&quot; iex&gt; Linker.offline_link( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;../page1.html&quot; iex&gt; ) &quot;../../../hello.world/page1.html&quot; iex&gt; Linker.offline_link( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;http://thank.you/page1&quot; iex&gt; ) &quot;../../../thank.you/page1/index.html&quot; iex&gt; Linker.offline_link( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;http://thank.you/page1.html&quot; iex&gt; ) &quot;../../../thank.you/page1.html&quot;","ref":"Crawler.Linker.html#offline_link/2","title":"Crawler.Linker.offline_link/2","type":"function"},{"doc":"Given the current_link, it works out what the offline URL should be for link. Examples iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;page1&quot; iex&gt; ) &quot;http://hello.world/dir/page1/index.html&quot; iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;page1.html&quot; iex&gt; ) &quot;http://hello.world/dir/page1.html&quot; iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;../page1&quot; iex&gt; ) &quot;http://hello.world/page1/index.html&quot; iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;../page1.html&quot; iex&gt; ) &quot;http://hello.world/page1.html&quot; iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;http://thank.you/page1&quot; iex&gt; ) &quot;http://thank.you/page1/index.html&quot; iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;http://thank.you/page1.html&quot; iex&gt; ) &quot;http://thank.you/page1.html&quot; iex&gt; Linker.offline_url( iex&gt; &quot;http://hello.world/dir/page&quot;, iex&gt; &quot;http://thank.you/&quot; iex&gt; ) &quot;http://thank.you/index.html&quot;","ref":"Crawler.Linker.html#offline_url/2","title":"Crawler.Linker.offline_url/2","type":"function"},{"doc":"Given the current_link, it works out what the URL should be for link. Examples iex&gt; Linker.url( iex&gt; &quot;http://another.domain:8888/page&quot;, iex&gt; &quot;/dir/page2&quot; iex&gt; ) &quot;http://another.domain:8888/dir/page2&quot; iex&gt; Linker.url( iex&gt; &quot;http://another.domain:8888/parent/page&quot;, iex&gt; &quot;dir/page2&quot; iex&gt; ) &quot;http://another.domain:8888/parent/dir/page2&quot;","ref":"Crawler.Linker.html#url/2","title":"Crawler.Linker.url/2","type":"function"},{"doc":"Builds a path for a link (can be a URL itself or a relative link) based on the input string which is a URL with or without its protocol.","ref":"Crawler.Linker.PathBuilder.html","title":"Crawler.Linker.PathBuilder","type":"module"},{"doc":"Builds a path for a link (can be a URL itself or a relative link) based on the input string which is a URL with or without its protocol. Examples iex&gt; PathBuilder.build_path( iex&gt; &quot;https://cool.beans:7777/dir/page1&quot;, iex&gt; &quot;https://hello.world:8888/remote/page2&quot; iex&gt; ) &quot;hello.world-8888/remote/page2&quot; iex&gt; PathBuilder.build_path( iex&gt; &quot;https://cool.beans:7777/dir/page1&quot;, iex&gt; &quot;local/page2&quot; iex&gt; ) &quot;cool.beans-7777/dir/local/page2&quot; iex&gt; PathBuilder.build_path( iex&gt; &quot;https://cool.beans:7777/dir/page1&quot;, iex&gt; &quot;/local/page2&quot; iex&gt; ) &quot;cool.beans-7777/local/page2&quot; iex&gt; PathBuilder.build_path( iex&gt; &quot;https://cool.beans:7777/parent/dir/page1&quot;, iex&gt; &quot;../local/page2&quot; iex&gt; ) &quot;cool.beans-7777/parent/local/page2&quot; iex&gt; PathBuilder.build_path( iex&gt; &quot;https://cool.beans:7777/parent/dir/page1&quot;, iex&gt; &quot;../../local/page2&quot; iex&gt; ) &quot;cool.beans-7777/local/page2&quot;","ref":"Crawler.Linker.PathBuilder.html#build_path/3","title":"Crawler.Linker.PathBuilder.build_path/3","type":"function"},{"doc":"Expands the path by expanding any . and .. characters. See this pull request.","ref":"Crawler.Linker.PathExpander.html","title":"Crawler.Linker.PathExpander","type":"module"},{"doc":"Expands the path by expanding any . and .. characters. Note this function only expands any . and .. characters within the given path, and it does not take into account the absolute or relative nature of the path itself, for that please use expand/1 or expand/2. Examples ### Intended use case iex&gt; PathExpander.expand_dot(&quot;foo/bar/../baz&quot;) &quot;foo/baz&quot; iex&gt; PathExpander.expand_dot(&quot;/foo/bar/../baz&quot;) &quot;/foo/baz&quot; ### Non-intended use cases are ignored iex&gt; PathExpander.expand_dot(&quot;foo/bar/./baz&quot;) &quot;foo/bar/baz&quot; iex&gt; PathExpander.expand_dot(&quot;../foo/bar&quot;) &quot;foo/bar&quot;","ref":"Crawler.Linker.PathExpander.html#expand_dot/1","title":"Crawler.Linker.PathExpander.expand_dot/1","type":"function"},{"doc":"Finds different components of a given URL, e.g. its domain name, directory path, or full path. The safe option in some the functions indicates whether the return value should be transformed in order to be safely used as folder and file names.","ref":"Crawler.Linker.PathFinder.html","title":"Crawler.Linker.PathFinder","type":"module"},{"doc":"Finds the base path of a given page. Examples iex&gt; PathFinder.find_base_path(&quot;http://hi.hello&quot;) &quot;hi.hello&quot; iex&gt; PathFinder.find_base_path(&quot;https://hi.hello:8888/dir/world&quot;) &quot;hi.hello-8888/dir&quot; iex&gt; PathFinder.find_base_path(&quot;https://hi.hello:8888/dir/world&quot;, false) &quot;hi.hello:8888/dir&quot;","ref":"Crawler.Linker.PathFinder.html#find_base_path/2","title":"Crawler.Linker.PathFinder.find_base_path/2","type":"function"},{"doc":"Finds the domain name with port number (e.g. example.org:8080). Examples iex&gt; PathFinder.find_domain(&quot;http://hi.hello&quot;) &quot;hi.hello&quot; iex&gt; PathFinder.find_domain(&quot;https://hi.hello:8888/world&quot;) &quot;hi.hello-8888&quot; iex&gt; PathFinder.find_domain(&quot;https://hi.hello:8888/world&quot;, false) &quot;hi.hello:8888&quot;","ref":"Crawler.Linker.PathFinder.html#find_domain/2","title":"Crawler.Linker.PathFinder.find_domain/2","type":"function"},{"doc":"Finds the full path of a given page. Examples iex&gt; PathFinder.find_path(&quot;http://hi.hello&quot;) &quot;hi.hello&quot; iex&gt; PathFinder.find_path(&quot;https://hi.hello:8888/world&quot;) &quot;hi.hello-8888/world&quot; iex&gt; PathFinder.find_path(&quot;https://hi.hello:8888/world&quot;, false) &quot;hi.hello:8888/world&quot;","ref":"Crawler.Linker.PathFinder.html#find_path/2","title":"Crawler.Linker.PathFinder.find_path/2","type":"function"},{"doc":"Finds the URL scheme (e.g. https://). Examples iex&gt; PathFinder.find_scheme(&quot;http://hi.hello&quot;) &quot;http://&quot; iex&gt; PathFinder.find_scheme(&quot;https://hi.hello:8888/&quot;) &quot;https://&quot;","ref":"Crawler.Linker.PathFinder.html#find_scheme/1","title":"Crawler.Linker.PathFinder.find_scheme/1","type":"function"},{"doc":"Transforms a link to be storeable and linkable offline.","ref":"Crawler.Linker.PathOffliner.html","title":"Crawler.Linker.PathOffliner","type":"module"},{"doc":"Transforms a given link so that it can be stored and linked to by other pages. When a page does not have a file extension (e.g. html) it is treated as the index page for a directory, therefore index.html is appended to the link. Examples iex&gt; PathOffliner.transform(&quot;http://hello.world&quot;) &quot;http://hello.world/index.html&quot; iex&gt; PathOffliner.transform(&quot;hello.world&quot;) &quot;hello.world/index.html&quot; iex&gt; PathOffliner.transform(&quot;hello.world/&quot;) &quot;hello.world/index.html&quot; iex&gt; PathOffliner.transform(&quot;hello/world&quot;) &quot;hello/world/index.html&quot; iex&gt; PathOffliner.transform(&quot;hello/world.html&quot;) &quot;hello/world.html&quot;","ref":"Crawler.Linker.PathOffliner.html#transform/1","title":"Crawler.Linker.PathOffliner.transform/1","type":"function"},{"doc":"Returns prefixes (../s) according to the given URL&#39;s structure.","ref":"Crawler.Linker.PathPrefixer.html","title":"Crawler.Linker.PathPrefixer","type":"module"},{"doc":"Returns prefixes (../s) according to the given URL&#39;s structure. Examples iex&gt; PathPrefixer.prefix(&quot;https://hello.world/&quot;) &quot;../&quot; iex&gt; PathPrefixer.prefix(&quot;https://hello.world/page.html&quot;) &quot;../&quot; iex&gt; PathPrefixer.prefix(&quot;https://hello.world/page&quot;) &quot;../../&quot; iex&gt; PathPrefixer.prefix(&quot;https://hello.world/dir/page.html&quot;) &quot;../../&quot; iex&gt; PathPrefixer.prefix(&quot;https://hello.world/dir/page&quot;) &quot;../../../&quot;","ref":"Crawler.Linker.PathPrefixer.html#prefix/1","title":"Crawler.Linker.PathPrefixer.prefix/1","type":"function"},{"doc":"Options for the crawler.","ref":"Crawler.Options.html","title":"Crawler.Options","type":"module"},{"doc":"Assigns default option values. Examples iex&gt; Options.assign_defaults(%{}) |&gt; Map.has_key?(:depth) true iex&gt; Options.assign_defaults(%{}) |&gt; Map.get(:max_depths) 3 iex&gt; Options.assign_defaults(%{max_depths: 4}) |&gt; Map.get(:max_depths) 4","ref":"Crawler.Options.html#assign_defaults/1","title":"Crawler.Options.assign_defaults/1","type":"function"},{"doc":"Takes the url argument and puts it in the opts. The opts map gets passed around internally and eventually gets stored in the registry. Examples iex&gt; Options.assign_url(%{}, &quot;http://options/&quot;) %{url: &quot;http://options/&quot;} iex&gt; Options.assign_url(%{url: &quot;http://example.com/&quot;}, &quot;http://options/&quot;) %{url: &quot;http://options/&quot;}","ref":"Crawler.Options.html#assign_url/2","title":"Crawler.Options.assign_url/2","type":"function"},{"doc":"Parses pages and calls a link handler to handle the detected links.","ref":"Crawler.Parser.html","title":"Crawler.Parser","type":"module"},{"doc":"Parses the links and returns the page. There are two hooks: link_handler is useful when a custom parser calls this default parser and utilises a different link handler for processing links. scraper is useful for scraping content immediately as the parser parses the page, alternatively you can simply access the crawled data asynchronously, refer to the README Examples iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: &quot;Body&quot;, iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;a&quot;, content_type: &quot;text/html&quot;} iex&gt; }) iex&gt; page.body &quot;Body&quot; iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: &quot;&lt;a href=&#39;http://parser/1&#39;&gt;Link&lt;/a&gt;&quot;, iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;a&quot;, content_type: &quot;text/html&quot;} iex&gt; }) iex&gt; page.body &quot;&lt;a href=&#39;http://parser/1&#39;&gt;Link&lt;/a&gt;&quot; iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: &quot;&lt;a name=&#39;hello&#39;&gt;Link&lt;/a&gt;&quot;, iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;a&quot;, content_type: &quot;text/html&quot;} iex&gt; }) iex&gt; page.body &quot;&lt;a name=&#39;hello&#39;&gt;Link&lt;/a&gt;&quot; iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: &quot;&lt;a href=&#39;http://parser/2&#39; target=&#39;_blank&#39;&gt;Link&lt;/a&gt;&quot;, iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;a&quot;, content_type: &quot;text/html&quot;} iex&gt; }) iex&gt; page.body &quot;&lt;a href=&#39;http://parser/2&#39; target=&#39;_blank&#39;&gt;Link&lt;/a&gt;&quot; iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: &quot;&lt;a href=&#39;parser/2&#39;&gt;Link&lt;/a&gt;&quot;, iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;a&quot;, content_type: &quot;text/html&quot;, referrer_url: &quot;http://hello&quot;} iex&gt; }) iex&gt; page.body &quot;&lt;a href=&#39;parser/2&#39;&gt;Link&lt;/a&gt;&quot; iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: &quot;&lt;a href=&#39;../parser/2&#39;&gt;Link&lt;/a&gt;&quot;, iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;a&quot;, content_type: &quot;text/html&quot;, referrer_url: &quot;http://hello&quot;} iex&gt; }) iex&gt; page.body &quot;&lt;a href=&#39;../parser/2&#39;&gt;Link&lt;/a&gt;&quot; iex&gt; {:ok, page} = Parser.parse(%Page{ iex&gt; body: image_file(), iex&gt; opts: %{scraper: Crawler.Scraper, html_tag: &quot;img&quot;, content_type: &quot;image/png&quot;} iex&gt; }) iex&gt; page.body &quot;\#{image_file()}&quot;","ref":"Crawler.Parser.html#parse/1","title":"Crawler.Parser.parse/1","type":"function"},{"doc":"","ref":"Crawler.Parser.html#parse_links/3","title":"Crawler.Parser.parse_links/3","type":"function"},{"doc":"Parses CSS files.","ref":"Crawler.Parser.CssParser.html","title":"Crawler.Parser.CssParser","type":"module"},{"doc":"Parses CSS files. Examples iex&gt; CssParser.parse( iex&gt; &quot;img { url(http://hello.world) }&quot; iex&gt; ) [{&quot;link&quot;, [{&quot;href&quot;, &quot;http://hello.world&quot;}], []}] iex&gt; CssParser.parse( iex&gt; &quot;@font-face { src: url(&#39;icons.ttf&#39;) format(&#39;truetype&#39;); }&quot; iex&gt; ) [{&quot;link&quot;, [{&quot;href&quot;, &quot;icons.ttf&quot;}], []}] iex&gt; CssParser.parse( iex&gt; &quot;@font-face { src: url(&#39;data:applicatin/blah&#39;); }&quot; iex&gt; ) []","ref":"Crawler.Parser.CssParser.html#parse/1","title":"Crawler.Parser.CssParser.parse/1","type":"function"},{"doc":"Detects whether a page is parsable.","ref":"Crawler.Parser.Guarder.html","title":"Crawler.Parser.Guarder","type":"module"},{"doc":"Detects whether a page is parsable. Examples iex&gt; Guarder.pass?( iex&gt; %{html_tag: &quot;link&quot;, content_type: &quot;text/css&quot;} iex&gt; ) true iex&gt; Guarder.pass?( iex&gt; %{html_tag: &quot;img&quot;, content_type: &quot;text/css&quot;} iex&gt; ) false iex&gt; Guarder.pass?( iex&gt; %{html_tag: &quot;link&quot;, content_type: &quot;text/css&quot;} iex&gt; ) true iex&gt; Guarder.pass?( iex&gt; %{html_tag: &quot;link&quot;, content_type: &quot;image/png&quot;} iex&gt; ) false","ref":"Crawler.Parser.Guarder.html#pass?/1","title":"Crawler.Parser.Guarder.pass?/1","type":"function"},{"doc":"Parses HTML files.","ref":"Crawler.Parser.HtmlParser.html","title":"Crawler.Parser.HtmlParser","type":"module"},{"doc":"Parses HTML files. Examples iex&gt; HtmlParser.parse( iex&gt; &quot;&lt;a href=&#39;http://hello.world&#39;&gt;Link&lt;/a&gt;&quot;, iex&gt; %{} iex&gt; ) [{&quot;a&quot;, [{&quot;href&quot;, &quot;http://hello.world&quot;}], [&quot;Link&quot;]}] iex&gt; HtmlParser.parse( iex&gt; &quot;&lt;script type=&#39;text/javascript&#39;&gt;js&lt;/script&gt;&quot;, iex&gt; %{assets: [&quot;js&quot;]} iex&gt; ) []","ref":"Crawler.Parser.HtmlParser.html#parse/2","title":"Crawler.Parser.HtmlParser.parse/2","type":"function"},{"doc":"Parses links and transforms them if necessary.","ref":"Crawler.Parser.LinkParser.html","title":"Crawler.Parser.LinkParser","type":"module"},{"doc":"Parses links and transforms them if necessary. Examples iex&gt; LinkParser.parse( iex&gt; {&quot;a&quot;, [{&quot;hello&quot;, &quot;world&quot;}, {&quot;href&quot;, &quot;http://hello.world&quot;}], []}, iex&gt; %{}, iex&gt; &amp;Kernel.inspect(&amp;1, Enum.into(&amp;2, [])) iex&gt; ) &quot;{\\&quot;href\\&quot;, \\&quot;http://hello.world\\&quot;}&quot; iex&gt; LinkParser.parse( iex&gt; {&quot;img&quot;, [{&quot;hello&quot;, &quot;world&quot;}, {&quot;src&quot;, &quot;http://hello.world&quot;}], []}, iex&gt; %{}, iex&gt; &amp;Kernel.inspect(&amp;1, Enum.into(&amp;2, [])) iex&gt; ) &quot;{\\&quot;src\\&quot;, \\&quot;http://hello.world\\&quot;}&quot;","ref":"Crawler.Parser.LinkParser.html#parse/3","title":"Crawler.Parser.LinkParser.parse/3","type":"function"},{"doc":"Expands a link into a full URL.","ref":"Crawler.Parser.LinkParser.LinkExpander.html","title":"Crawler.Parser.LinkParser.LinkExpander","type":"module"},{"doc":"Expands a link into a full URL. Examples iex&gt; LinkExpander.expand({&quot;href&quot;, &quot;http://hello.world&quot;}, %{}) {&quot;href&quot;, &quot;http://hello.world&quot;} iex&gt; LinkExpander.expand({&quot;href&quot;, &quot;page&quot;}, %{referrer_url: &quot;http://hello.world&quot;}) {&quot;link&quot;, &quot;page&quot;, &quot;href&quot;, &quot;http://hello.world/page&quot;}","ref":"Crawler.Parser.LinkParser.LinkExpander.html#expand/2","title":"Crawler.Parser.LinkParser.LinkExpander.expand/2","type":"function"},{"doc":"Spec for defining a parser.","ref":"Crawler.Parser.Spec.html","title":"Crawler.Parser.Spec","type":"behaviour"},{"doc":"","ref":"Crawler.Parser.Spec.html#c:parse/1","title":"Crawler.Parser.Spec.parse/1","type":"callback"},{"doc":"","ref":"Crawler.Parser.Spec.html#t:body/0","title":"Crawler.Parser.Spec.body/0","type":"type"},{"doc":"","ref":"Crawler.Parser.Spec.html#t:opts/0","title":"Crawler.Parser.Spec.opts/0","type":"type"},{"doc":"","ref":"Crawler.Parser.Spec.html#t:page/0","title":"Crawler.Parser.Spec.page/0","type":"type"},{"doc":"","ref":"Crawler.Parser.Spec.html#t:url/0","title":"Crawler.Parser.Spec.url/0","type":"type"},{"doc":"Handles the queueing of crawl requests.","ref":"Crawler.QueueHandler.html","title":"Crawler.QueueHandler","type":"module"},{"doc":"Enqueues a crawl request. Also initialises the queue if it&#39;s not already initialised, this is necessary so that consumer apps don&#39;t have to manually handle the queue initialisation.","ref":"Crawler.QueueHandler.html#enqueue/1","title":"Crawler.QueueHandler.enqueue/1","type":"function"},{"doc":"A placeholder module that demonstrates the scraping interface.","ref":"Crawler.Scraper.html","title":"Crawler.Scraper","type":"module"},{"doc":"","ref":"Crawler.Scraper.html#scrape/1","title":"Crawler.Scraper.scrape/1","type":"function"},{"doc":"Spec for defining a scraper.","ref":"Crawler.Scraper.Spec.html","title":"Crawler.Scraper.Spec","type":"behaviour"},{"doc":"","ref":"Crawler.Scraper.Spec.html#c:scrape/1","title":"Crawler.Scraper.Spec.scrape/1","type":"callback"},{"doc":"","ref":"Crawler.Scraper.Spec.html#t:body/0","title":"Crawler.Scraper.Spec.body/0","type":"type"},{"doc":"","ref":"Crawler.Scraper.Spec.html#t:opts/0","title":"Crawler.Scraper.Spec.opts/0","type":"type"},{"doc":"","ref":"Crawler.Scraper.Spec.html#t:page/0","title":"Crawler.Scraper.Spec.page/0","type":"type"},{"doc":"","ref":"Crawler.Scraper.Spec.html#t:url/0","title":"Crawler.Scraper.Spec.url/0","type":"type"},{"doc":"Stores crawled pages offline.","ref":"Crawler.Snapper.html","title":"Crawler.Snapper","type":"module"},{"doc":"In order to store pages offline, it provides the following functionalities: replaces all URLs to their equivalent relative paths creates directories when necessary to store the files Examples iex&gt; Snapper.snap(&quot;hello&quot;, %{save_to: tmp(&quot;snapper&quot;), url: &quot;http://hello-world.local&quot;}) iex&gt; File.read(tmp(&quot;snapper/hello-world.local&quot;, &quot;index.html&quot;)) {:ok, &quot;hello&quot;} iex&gt; Snapper.snap(&quot;hello&quot;, %{save_to: tmp(&quot;snapper&quot;), url: &quot;http://snapper.local/index.html&quot;}) iex&gt; File.read(tmp(&quot;snapper/snapper.local&quot;, &quot;index.html&quot;)) {:ok, &quot;hello&quot;} iex&gt; Snapper.snap(&quot;hello&quot;, %{save_to: &quot;nope&quot;, url: &quot;http://snapper.local/index.html&quot;}) {:error, &quot;Cannot write to file nope/snapper.local/index.html, reason: enoent&quot;} iex&gt; Snapper.snap(&quot;hello&quot;, %{save_to: tmp(&quot;snapper&quot;), url: &quot;http://snapper.local/hello&quot;}) iex&gt; File.read(tmp(&quot;snapper/snapper.local/hello&quot;, &quot;index.html&quot;)) {:ok, &quot;hello&quot;} iex&gt; Snapper.snap(&quot;hello&quot;, %{save_to: tmp(&quot;snapper&quot;), url: &quot;http://snapper.local/hello1/&quot;}) iex&gt; File.read(tmp(&quot;snapper/snapper.local/hello1&quot;, &quot;index.html&quot;)) {:ok, &quot;hello&quot;} iex&gt; Snapper.snap( iex&gt; &quot;&lt;a href=&#39;http://another.domain/page&#39;&gt;&lt;/a&gt;&quot;, iex&gt; %{ iex&gt; save_to: tmp(&quot;snapper&quot;), iex&gt; url: &quot;http://snapper.local/depth0&quot;, iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot;, iex&gt; content_type: &quot;text/html&quot;, iex&gt; } iex&gt; ) iex&gt; File.read(tmp(&quot;snapper/snapper.local/depth0&quot;, &quot;index.html&quot;)) {:ok, &quot;&lt;a href=&#39;../../another.domain/page/index.html&#39;&gt;&lt;/a&gt;&quot;} iex&gt; Snapper.snap( iex&gt; &quot;&lt;a href=&#39;https://another.domain:8888/page&#39;&gt;&lt;/a&gt;&quot;, iex&gt; %{ iex&gt; save_to: tmp(&quot;snapper&quot;), iex&gt; url: &quot;http://snapper.local:7777/dir/depth1&quot;, iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot;, iex&gt; content_type: &quot;text/html&quot;, iex&gt; } iex&gt; ) iex&gt; File.read(tmp(&quot;snapper/snapper.local-7777/dir/depth1&quot;, &quot;index.html&quot;)) {:ok, &quot;&lt;a href=&#39;../../../another.domain-8888/page/index.html&#39;&gt;&lt;/a&gt;&quot;}","ref":"Crawler.Snapper.html#snap/2","title":"Crawler.Snapper.snap/2","type":"function"},{"doc":"Makes a new (nested) folder according to the options provided.","ref":"Crawler.Snapper.DirMaker.html","title":"Crawler.Snapper.DirMaker","type":"module"},{"doc":"Makes a new (nested) folder according to the options provided. Examples iex&gt; DirMaker.make_dir( iex&gt; save_to: tmp(&quot;snapper/dir_creator&quot;), iex&gt; url: &quot;http://hello-world.local&quot; iex&gt; ) iex&gt; |&gt; Path.relative_to_cwd &quot;test/tmp/snapper/dir_creator/hello-world.local/index.html&quot;","ref":"Crawler.Snapper.DirMaker.html#make_dir/1","title":"Crawler.Snapper.DirMaker.make_dir/1","type":"function"},{"doc":"Replaces links found in a page so they work offline.","ref":"Crawler.Snapper.LinkReplacer.html","title":"Crawler.Snapper.LinkReplacer","type":"module"},{"doc":"Replaces links found in a page so they work offline. Examples iex&gt; LinkReplacer.replace_links( iex&gt; &quot;&lt;a href=&#39;http://another.domain/page.html&#39;&gt;&lt;/a&gt;&quot;, iex&gt; %{ iex&gt; url: &quot;http://main.domain/dir/page&quot;, iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot;, iex&gt; content_type: &quot;text/html&quot;, iex&gt; } iex&gt; ) {:ok, &quot;&lt;a href=&#39;../../../another.domain/page.html&#39;&gt;&lt;/a&gt;&quot;} iex&gt; LinkReplacer.replace_links( iex&gt; &quot;&lt;a href=&#39;http://another.domain/dir/page.html&#39;&gt;&lt;/a&gt;&quot;, iex&gt; %{ iex&gt; url: &quot;http://main.domain/page&quot;, iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot;, iex&gt; content_type: &quot;text/html&quot;, iex&gt; } iex&gt; ) {:ok, &quot;&lt;a href=&#39;../../another.domain/dir/page.html&#39;&gt;&lt;/a&gt;&quot;} iex&gt; LinkReplacer.replace_links( iex&gt; &quot;&lt;a href=&#39;http://another.domain/dir/page&#39;&gt;&lt;/a&gt;&quot;, iex&gt; %{ iex&gt; url: &quot;http://main.domain/dir/page&quot;, iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot;, iex&gt; content_type: &quot;text/html&quot;, iex&gt; } iex&gt; ) {:ok, &quot;&lt;a href=&#39;../../../another.domain/dir/page/index.html&#39;&gt;&lt;/a&gt;&quot;} iex&gt; LinkReplacer.replace_links( iex&gt; &quot;&lt;a href=&#39;/dir/page2.html&#39;&gt;&lt;/a&gt;&quot;, iex&gt; %{ iex&gt; url: &quot;http://main.domain/dir/page&quot;, iex&gt; referrer_url: &quot;http://main.domain/dir/page&quot;, iex&gt; depth: 1, iex&gt; max_depths: 2, iex&gt; html_tag: &quot;a&quot;, iex&gt; content_type: &quot;text/html&quot;, iex&gt; } iex&gt; ) {:ok, &quot;&lt;a href=&#39;../../../main.domain/dir/page2.html&#39;&gt;&lt;/a&gt;&quot;}","ref":"Crawler.Snapper.LinkReplacer.html#replace_links/2","title":"Crawler.Snapper.LinkReplacer.replace_links/2","type":"function"},{"doc":"An internal data store for information related to each crawl.","ref":"Crawler.Store.html","title":"Crawler.Store","type":"module"},{"doc":"Adds a URL to the registry.","ref":"Crawler.Store.html#add/1","title":"Crawler.Store.add/1","type":"function"},{"doc":"Adds the page data for a URL to the registry.","ref":"Crawler.Store.html#add_page_data/3","title":"Crawler.Store.add_page_data/3","type":"function"},{"doc":"Finds a stored URL and returns its page data.","ref":"Crawler.Store.html#find/1","title":"Crawler.Store.find/1","type":"function"},{"doc":"Finds a stored URL and returns its page data only if it&#39;s processed.","ref":"Crawler.Store.html#find_processed/1","title":"Crawler.Store.find_processed/1","type":"function"},{"doc":"Initialises a new Registry named Crawler.Store.DB.","ref":"Crawler.Store.html#init/0","title":"Crawler.Store.init/0","type":"function"},{"doc":"Marks a URL as processed in the registry.","ref":"Crawler.Store.html#processed/1","title":"Crawler.Store.processed/1","type":"function"},{"doc":"An internal struct for keeping the url and content of a crawled page.","ref":"Crawler.Store.Page.html","title":"Crawler.Store.Page","type":"module"},{"doc":"Handles the crawl tasks.","ref":"Crawler.Worker.html","title":"Crawler.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Crawler.Worker.html#child_spec/1","title":"Crawler.Worker.child_spec/1","type":"function"},{"doc":"A crawl workflow that delegates responsibilities to: Crawler.Fetcher.fetch/1 Crawler.Parser.parse/1 (or a custom parser)","ref":"Crawler.Worker.html#handle_cast/2","title":"Crawler.Worker.handle_cast/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawler.Worker.html#init/1","title":"Crawler.Worker.init/1","type":"function"},{"doc":"Runs the worker that casts data to itself to kick off the crawl workflow.","ref":"Crawler.Worker.html#run/1","title":"Crawler.Worker.run/1","type":"function"}]